unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    Timer1: TTimer;
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure Rajzol(oszlop,magassag:integer; szin:TColor);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  a: array[0..19] of integer;
  legmagasabb: integer;

procedure TForm1.Rajzol(oszlop,magassag:integer; szin:TColor);
begin
 Image1.Canvas.Brush.Color := szin;
 Image1.Canvas.FillRect(Rect(oszlop*20+1,Image1.Height-15-a[oszlop],oszlop*20+20,Image1.Height-15));
 Image1.Canvas.Brush.Color := clWhite;
 Image1.Canvas.TextOut(oszlop*20+5, Image1.Height-15-a[oszlop]-14, IntToStr(a[oszlop]));
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize;
  Image1.Canvas.Create;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i:integer;
begin
  // letorli a rajzot
  Image1.Canvas.Brush.Color := clWhite;
  Image1.Canvas.FillRect(Rect(0,0,Image1.Width,Image1.Height));
  // beallitja az ertekeket 0-ra es kirajzolja az oszlopokat
  for i := 0 to 19 do begin
                      a[i] := 0;
                      Rajzol(i,a[i],clGreen);
                      Image1.Canvas.TextOut(i*20+5, Image1.Height-14, IntToStr(i));
                      end;
  legmagasabb := 0;
  // elinditja a timer-t
  timer1.Enabled := true;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  i,r:integer;
begin
  r := random(20);
  // noveljuk 1-gyel az r. elemet, majd kirajzoljuk
  a[r] := a[r] + 1;
  Rajzol(r,a[r],clGreen);
  // ha ez magasabb, mint a legmagasabb, atszinezzuk a regieket
  // zoldre, az uj magassagut pedig pirosra
  if legmagasabb<a[r] then
    begin
    for i:=0 to 19 do
      if a[i]=legmagasabb then Rajzol(i,a[i],clGreen);
    legmagasabb := a[r];
    Rajzol(r,a[r],clRed);
    end
  else  // ha az uj oszlop is a legmagasabbak koze tartozik, atszinezzuk pirosra
    if legmagasabb=a[r] then Rajzol(r,a[r],clRed);
  // ha elertuk a 99-et, vege
  if a[r] = 99 then begin
                    Timer1.Enabled := false;
                    end;
end;

end.
