unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Unit2;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button2Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// szemely tipus definialasa
type TSzemely = record
                 Nev, Tel: string[255];
                end;

// tomb, fajl deklaralasa az adatok tarolasara
// n - a tombben levo szemelyek szama
var a: array [1..10000] of TSzemely;
    f: file of TSzemely;
    n: integer;

procedure TForm1.FormCreate(Sender: TObject);
begin
 n:=0;
 Label3.Caption := '';
 Label4.Caption := '';
 // adatok beolvasasa kulso fajlbol
 AssignFile(f,'telkonyv.dat');
 try
   Reset(f);
   try
     while not eof(f) do
       begin
         inc(n);
         Read(f,a[n]);
         ListBox1.Items.Add(a[n].Nev);
       end;
   finally
     CloseFile(f);
   end;
 except
   MessageDlg('Hiba az adatok megnyitasakor.'
               + chr(10) + chr(13) + 'A file nem letezik?',
               mtWarning,[mbOK],0);
 end;
 // elso nev, telefonszam megjelenitese
 if n>0 then begin
             ListBox1.ItemIndex := 0;
             ListBox1Click(ListBox1);
             end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i: integer;
begin
  // ha mar tele a tomb
  if n=10000 then
    ShowMessage('Sajnos tbb szemlyt nem tarolhat a programban!')
  // uj szemely hozzaadasa
  else
   if Form2.ShowModal=mrOk then
    begin
      // szemely helyenek megkeresese a tombben (abc szerint)
      inc(n);
      i:=n-1;
      while (i>0) and (UpperCase(a[i].Nev)>UpperCase(Form2.Edit1.Text)) do
        begin
          a[i+1] := a[i];
          dec(i);
        end;
      a[i+1].Nev := Form2.Edit1.Text;
      a[i+1].Tel := Form2.Edit2.Text;
      // az eppen beirt szemely adatainak megjelenitese
      ListBox1.Items.Insert(i,Form2.Edit1.Text);
      ListBox1.ItemIndex := i;
      ListBox1Click(ListBox1);
    end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  // a kivalasztott szemely adatainak megjelenitese
  Label3.Caption := a[ListBox1.ItemIndex+1].Nev;
  Label4.Caption := a[ListBox1.ItemIndex+1].Tel;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  i: integer;
begin
  // tobbi szemely elobbre tolasa 1-gyel a tombben
  for i:=ListBox1.ItemIndex+1 to n-1 do a[i]:=a[i+1];
  dec(n);
  // torles a listabol
  i:=ListBox1.ItemIndex;
  ListBox1.Items.Delete(ListBox1.ItemIndex);
  // a kovetkezo szemely adatainak megjelenitese
  // (ha nincs kovetkezo, akkor az elotte levo)
  // ha van meg szemely a listaban
  if i<n then begin
              ListBox1.ItemIndex := i;
              ListBox1Click(ListBox1);
              end
         else if n>0 then begin
                          ListBox1.ItemIndex := n-1;
                          ListBox1Click(ListBox1);
                          end
                     else begin
                          Label3.Caption := '';
                          Label4.Caption := '';
                          end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i: integer;
begin
 // adatok mentese fajlba
 try
   Rewrite(f);
   try
     for i:=1 to n do Write(f,a[i]);
   finally
     CloseFile(f);
   end;
 except
   MessageDlg('Hiba az adatok mentsnl!',
               mtError,[mbOK],0);
 end;
end;

end.
