unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Timer1: TTimer;
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

var
  egerpoz1,egerpoz2: TPoint;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  randomize;
  Image1.Top := Random(Screen.Height-200);
  Image1.Left := Random(Screen.Width-200);
  Form1.Color := clBlack;
  Form1.Cursor := crNone;
  Form1.DoubleBuffered := true;
  GetCursorPos(egerpoz1);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var elmozdulas:integer;
begin
  Image1.Left := Image1.Left + 1;
  if Image1.Left > Form1.Width then
    begin
    Image1.Left := -Image1.Width;
    Image1.Top := Random(Form1.Height-200);
    end;
  GetCursorPos(egerpoz2);
  elmozdulas := round(sqrt(sqr(egerpoz1.x-egerpoz2.x)
                          +sqr(egerpoz1.y-egerpoz2.y)));
  if elmozdulas>10 then Form1.Close;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Form1.Close;
end;

end.
