unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IniFiles;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  IniFajl: TIniFile;
begin
  // letrehozunk egy TIniFile tipusu valtozot
  IniFajl := TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
  // megprobaljuk beolvasni az adatokat a fajlbol
  try
    Edit1.Text := IniFajl.ReadString('Edit','Text','');
    Top := IniFajl.ReadInteger('Form','Top',100);
    Left := IniFajl.ReadInteger('Form','Left',100);
    Width := IniFajl.ReadInteger('Form','Width',153);
    Height := IniFajl.ReadInteger('Form','Height',132);
    if IniFajl.ReadBool('Form','Maximized',false) then
      WindowState := wsMaximized
    else
      WindowState := wsNormal;
  // vegul felszabaditjuk a valtozot a memoriabol
  finally
    IniFajl.Free;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  IniFajl: TIniFile;
begin
  // letrehozunk egy TIniFile tipusu valtozot
  IniFajl := TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
  // megprobaljuk kiirni az adatokat a fajlbol
  try
    IniFajl.WriteString('Edit','Text',Edit1.Text);
    IniFajl.WriteInteger('Form','Top',Top);
    IniFajl.WriteInteger('Form','Left',Left);
    IniFajl.WriteInteger('Form','Width',Width);
    IniFajl.WriteInteger('Form','Height',Height);
    IniFajl.WriteBool('Form','Maximized',WindowState=wsMaximized);
  // vegul felszabaditjuk a valtozot a memoriabol
  finally
    IniFajl.Free;
  end;
end;

end.
